/**
 * metadata/RegistryObjectMetadata.java
 * <p>
 * File generated from the RegistryObjectMetadata uml Class
 * Generated by the Acceleo UML 2.1 to Java generator module (Obeo)
 */
package net.ihe.gazelle.metadata.model;

import net.ihe.gazelle.metadata.model.describer.ClassificationMetadataDescriber;
import net.ihe.gazelle.metadata.model.describer.ExternalIdentifierMetadataDescriber;
import net.ihe.gazelle.metadata.model.describer.SlotMetadataDescriber;
import net.ihe.gazelle.simulator.sut.model.Usage;
import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;
import org.jboss.seam.annotations.Name;

import javax.persistence.*;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;


/**
 * Description of the class RegistryObjectMetadata.
 *
 */

@Entity
@Name("registryObjectMetadata")
@Table(name = "registry_object_metadata", schema = "public")
@SequenceGenerator(name = "registry_object_sequence", sequenceName = "registry_object_id_seq", allocationSize = 1)
@Inheritance(strategy = InheritanceType.SINGLE_TABLE)
@DiscriminatorValue("RegistryObject")
@DiscriminatorColumn(name = "dtype", length = 31)
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "RegistryObjectMetadata", propOrder = {
        "id",
        "uuid",
        "name",
        "displayAttributeName",
        "value",
        "classificationDescriber",
        "slotDescriber",
        "ext_identifierDescriber",
        "usages"
})
@XmlRootElement(name = "RegistryObjectMetadata")

public class RegistryObjectMetadata implements Comparable<RegistryObjectMetadata>, Serializable {

    /**
     *
     */
    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "registry_object_sequence")
    private Integer id;

    private String uuid;

    private String name;

    private String displayAttributeName;

    private String value;

    @ManyToMany(cascade = {CascadeType.PERSIST})
    @Fetch(FetchMode.SUBSELECT)
    @JoinTable(name = "registry_object_metadata_usage")
    private List<Usage> usages;

    @ManyToMany(fetch = FetchType.EAGER, cascade = {CascadeType.ALL})
    @Fetch(FetchMode.SUBSELECT)
    @JoinTable(name = "registry_object_metadata_classificationdescriber")
    private List<ClassificationMetadataDescriber> classificationDescriber;


    @OneToMany(cascade = {CascadeType.ALL})
    @JoinTable(name = "registry_object_metadata_slotdescriber")
    private List<SlotMetadataDescriber> slotDescriber;


    @ManyToMany(fetch = FetchType.EAGER, cascade = {CascadeType.ALL})
    @Fetch(FetchMode.SUBSELECT)
    @JoinTable(name = "registry_object_metadata_ext_identifierdescriber")
    private List<ExternalIdentifierMetadataDescriber> ext_identifierDescriber;

    public String getDisplayAttributeName() {
        return displayAttributeName;
    }

    public void setDisplayAttributeName(String displayAttributeName) {
        this.displayAttributeName = displayAttributeName;
    }

    /**
     * Return id.
     * @return id
     */
    public Integer getId() {
        return id;
    }

    /**
     * Set a value to attribute id.
     * @param id.
     */
    public void setId(Integer id) {
        this.id = id;
    }


    /**
     * Return uuid.
     * @return uuid
     */
    public String getUuid() {
        return uuid;
    }

    /**
     * Set a value to attribute uuid.
     * @param uuid.
     */
    public void setUuid(String uuid) {
        this.uuid = uuid;
    }


    /**
     * Return name.
     * @return name
     */
    public String getName() {
        return name;
    }

    /**
     * Set a value to attribute name.
     * @param name.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Return classification.
     * @return classification
     */
    public List<ClassificationMetadataDescriber> getClassificationDescriber() {
        if (classificationDescriber == null) {
            classificationDescriber = new ArrayList<ClassificationMetadataDescriber>();
        }
        return classificationDescriber;
    }

    /**
     * Set a value to attribute classification.
     * @param classification.
     */
    public void setClassificationDescriber(List<ClassificationMetadataDescriber> classificationDescriber) {
        this.classificationDescriber = classificationDescriber;
    }


    /**
     * Add a classification to the classification collection.
     * @param classification_elt Element to add.
     */
    public void addClassification(ClassificationMetadataDescriber classification_elt) {
        this.classificationDescriber.add(classification_elt);
    }

    /**
     * Add a classification to the classification collection.
     * @param classification_elt Element to add.
     */
    public void addClassification(ClassificationMetaData classification_elt, String cardinality) {
        ClassificationMetadataDescriber tmp = new ClassificationMetadataDescriber();
        CardinalityEnum card = CardinalityEnum.getCardinalityFromValue(cardinality);
        tmp.setCardinality(card);
        tmp.setCmd(classification_elt);
        this.classificationDescriber.add(tmp);
    }


    public void editClassification(ClassificationMetadataDescriber res, ClassificationMetaData classification_elt, String cardinality) {
        System.out.println("eeeeeeeee");
        res.setCmd(classification_elt);
        res.setCardinality(CardinalityEnum.getCardinalityFromValue(cardinality));
    }


    /**
     * Remove a classification to the classification collection.
     * @param classification_elt Element to remove
     */
    public void removeClassification(ClassificationMetadataDescriber classification_elt) {
        this.classificationDescriber.remove(classification_elt);
    }


    /**
     * Return slot.
     * @return slot
     */
    public List<SlotMetadataDescriber> getSlotDescriber() {

        if (slotDescriber == null) {
            slotDescriber = new ArrayList<SlotMetadataDescriber>();
        }
        return slotDescriber;
    }

    /**
     * Set a value to attribute slot.
     * @param slot.
     */
    public void setSlotDescriber(List<SlotMetadataDescriber> slotDescriber) {
        this.slotDescriber = slotDescriber;
    }


    /**
     * Add a slot to the slot collection.
     * @param slot_elt Element to add.
     */
    public void addSlot(SlotMetadataDescriber slot_elt) {
        this.getSlotDescriber().add(slot_elt);
    }

    public void addSlot(SlotMetadata slotMetadata, String cardinality) {
        SlotMetadataDescriber tmp = new SlotMetadataDescriber();
        CardinalityEnum card = CardinalityEnum.getCardinalityFromValue(cardinality);
        tmp.setCardinality(card);
        tmp.setSlotMetadata(slotMetadata);
        this.getSlotDescriber().add(tmp);
    }


    /**
     * Remove a slot to the slot collection.
     * @param slot_elt Element to remove
     */
    public void removeSlot(SlotMetadataDescriber slot_elt) {
        this.getSlotDescriber().remove(slot_elt);
    }


    /**
     * Return ext_identifier.
     * @return ext_identifier
     */
    public List<ExternalIdentifierMetadataDescriber> getExt_identifierDescriber() {
        if (ext_identifierDescriber == null) {
            ext_identifierDescriber = new ArrayList<ExternalIdentifierMetadataDescriber>();
        }
        return ext_identifierDescriber;
    }

    /**
     * Set a value to attribute ext_identifier.
     * @param ext_identifier.
     */
    public void setExt_identifierDescriber(List<ExternalIdentifierMetadataDescriber> ext_identifierDescriber) {
        this.ext_identifierDescriber = ext_identifierDescriber;
    }

    public void editExt_identifier(ExternalIdentifierMetadataDescriber res, ExternalIdentifierMetadata ext_identifier_elt, String cardinality) {

        res.setEim(ext_identifier_elt);
        res.setCardinality(CardinalityEnum.getCardinalityFromValue(cardinality));
    }

    /**
     * Add a ext_identifier to the ext_identifier collection.
     * @param ext_identifier_elt Element to add.
     */
    public void addExt_identifier(ExternalIdentifierMetadataDescriber ext_identifier_elt) {
        this.ext_identifierDescriber.add(ext_identifier_elt);
    }

    public void addExt_identifier(ExternalIdentifierMetadata external_identifier, String cardinality) {
        ExternalIdentifierMetadataDescriber tmp = new ExternalIdentifierMetadataDescriber();
        CardinalityEnum card = CardinalityEnum.getCardinalityFromValue(cardinality);
        tmp.setCardinality(card);
        tmp.setEim(external_identifier);
        this.ext_identifierDescriber.add(tmp);
    }


    /**
     * Remove a ext_identifier to the ext_identifier collection.
     * @param ext_identifier_elt Element to remove
     */
    public void removeExt_identifier(ExternalIdentifierMetadataDescriber ext_identifier_elt) {
        this.ext_identifierDescriber.remove(ext_identifier_elt);
    }

    public void setUsages(List<Usage> usages) {
        this.usages = usages;
    }

    public List<Usage> getUsages() {
        if (usages == null) {
            usages = new ArrayList<Usage>();
        }
        return usages;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }


    @Override
    public int compareTo(RegistryObjectMetadata arg0) {
        if (this.getId() == null) {
            return -1;
        }
        if (arg0 == null) {
            return 1;
        }
        if (arg0.getId() == null) {
            return 1;
        }
        return this.getId().compareTo(arg0.getId());
    }

    public List<ClassificationMetaData> getClassification_optional() {

        List<ClassificationMetaData> classificationList = new ArrayList<ClassificationMetaData>();
        for (ClassificationMetadataDescriber classificationMetadataDescriber : classificationDescriber) {
            if (classificationMetadataDescriber.getCardinality().isOptional()) {
                classificationList.add(classificationMetadataDescriber.getCmd());
            }
        }
        return classificationList;
    }

    public List<ClassificationMetaData> getClassification_required() {

        List<ClassificationMetaData> classificationList = new ArrayList<ClassificationMetaData>();
        for (ClassificationMetadataDescriber classificationMetadataDescriber : classificationDescriber) {
            if (classificationMetadataDescriber.getCardinality().isRequired()) {
                classificationList.add(classificationMetadataDescriber.getCmd());
            }
        }
        return classificationList;
    }


    public List<ExternalIdentifierMetadata> getExt_identifier_optional() {

        List<ExternalIdentifierMetadata> externalIdentifierList = new ArrayList<ExternalIdentifierMetadata>();
        for (ExternalIdentifierMetadataDescriber externalIdentifierMetadataDescriber : ext_identifierDescriber) {
            if (externalIdentifierMetadataDescriber.getCardinality().isOptional()) {
                externalIdentifierList.add(externalIdentifierMetadataDescriber.getEim());
            }
        }
        return externalIdentifierList;
    }

    public List<ExternalIdentifierMetadata> getExt_identifier_required() {

        List<ExternalIdentifierMetadata> externalIdentifierList = new ArrayList<ExternalIdentifierMetadata>();
        for (ExternalIdentifierMetadataDescriber externalIdentifierMetadataDescriber : ext_identifierDescriber) {
            if (externalIdentifierMetadataDescriber.getCardinality().isRequired()) {
                externalIdentifierList.add(externalIdentifierMetadataDescriber.getEim());
            }
        }
        return externalIdentifierList;
    }

    public List<SlotMetadata> getSlot_optional() {

        List<SlotMetadata> slotList = new ArrayList<SlotMetadata>();
        for (SlotMetadataDescriber slotMetadataDescriber : this.getSlotDescriber()) {
            if (slotMetadataDescriber.getCardinality().isOptional()) {
                slotList.add(slotMetadataDescriber.getSlotMetadata());
            }
        }
        return slotList;
    }

    public List<SlotMetadata> getSlot_required() {

        List<SlotMetadata> slotList = new ArrayList<SlotMetadata>();
        for (SlotMetadataDescriber slotMetadataDescriber : this.getSlotDescriber()) {
            if (slotMetadataDescriber.getCardinality().isRequired()) {
                slotList.add(slotMetadataDescriber.getSlotMetadata());
            }
        }
        return slotList;
    }


    public List<ExternalIdentifierMetadata> getListExternalIdentifierMetadatas() {

        List<ExternalIdentifierMetadata> listExternalIdentifierMetadata = new ArrayList<ExternalIdentifierMetadata>();
        if (ext_identifierDescriber != null) {
            for (ExternalIdentifierMetadataDescriber externalIdentierMetadataDescriber : ext_identifierDescriber) {
                listExternalIdentifierMetadata.add(externalIdentierMetadataDescriber.getEim());
            }
        }

        return listExternalIdentifierMetadata;
    }

    public List<ClassificationMetaData> getListClassificationMetadatas() {
        List<ClassificationMetaData> listClassificationMetadata = new ArrayList<ClassificationMetaData>();
        if (classificationDescriber != null) {
            for (ClassificationMetadataDescriber classificationMetadataDescriber : classificationDescriber) {
                listClassificationMetadata.add(classificationMetadataDescriber.getCmd());
            }
        }

        return listClassificationMetadata;
    }

    public List<SlotMetadata> getListSlotMetadatas() {
        List<SlotMetadata> listSlotMetadata = new ArrayList<SlotMetadata>();
        if (slotDescriber != null) {
            for (SlotMetadataDescriber slotMetadataDescriber : slotDescriber) {
                listSlotMetadata.add(slotMetadataDescriber.getSlotMetadata());
            }
        }
        return listSlotMetadata;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((displayAttributeName == null) ? 0 : displayAttributeName.hashCode());
        result = prime * result + ((id == null) ? 0 : id.hashCode());
        result = prime * result + ((name == null) ? 0 : name.hashCode());
        result = prime * result + ((slotDescriber == null) ? 0 : slotDescriber.hashCode());
        result = prime * result + ((usages == null) ? 0 : usages.hashCode());
        result = prime * result + ((uuid == null) ? 0 : uuid.hashCode());
        result = prime * result + ((value == null) ? 0 : value.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        RegistryObjectMetadata other = (RegistryObjectMetadata) obj;
        if (displayAttributeName == null) {
            if (other.displayAttributeName != null) {
                return false;
            }
        } else if (!displayAttributeName.equals(other.displayAttributeName)) {
            return false;
        }
        if (id == null) {
            if (other.id != null) {
                return false;
            }
        } else if (!id.equals(other.id)) {
            return false;
        }
        if (name == null) {
            if (other.name != null) {
                return false;
            }
        } else if (!name.equals(other.name)) {
            return false;
        }
        if (slotDescriber == null) {
            if (other.slotDescriber != null) {
                return false;
            }
        } else if (!slotDescriber.equals(other.slotDescriber)) {
            return false;
        }
        if (usages == null) {
            if (other.usages != null) {
                return false;
            }
        } else if (!usages.equals(other.usages)) {
            return false;
        }
        if (uuid == null) {
            if (other.uuid != null) {
                return false;
            }
        } else if (!uuid.equals(other.uuid)) {
            return false;
        }
        if (value == null) {
            if (other.value != null) {
                return false;
            }
        } else if (!value.equals(other.value)) {
            return false;
        }
        return true;
    }

}